# -*- coding: utf-8 -*-
"""company_similarity.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1Uhf-r86s6WXXdh1dLvA6_Mc6bAB6bRXR
"""

import pandas as pd
import re
import numpy as np
from rapidfuzz.fuzz import partial_ratio as fuzz
from ai_parser.utils.misc import convert_accented_vietnamese_text
import urllib.request
from requests_html import HTML
from requests_html import HTMLSession

FUNCTIONS = [
    "accounting,auditing,tai chinh,tax,dau tu,financ,chung khoan",
    "thiet ke,design,art,do hoa",
    "quan ly,nhan su,tuyen dung,xa hoi,talent",
    'y duoc,duoc pham,thuc pham chuc nang,health,hospital,pharmacy, medi,bmi',
    'giao duc,du hoc,anh ngu,phap ngu',
    'spa,sac dep,my pham,duoc my pham,suc song',
    "quang cao,marketing,truyen thong,communication,media",
    'van chuyen,chuyen phat,giao hag',
    'bao ve',
    'fitness,yoga',
    'dia oc,estate,bat dong san,bds',
    'solar',
    'xay dung,building,kien truc',
    "phan mem,software,hardware,research,solution,tech,cong nghe",
    "ngan hang,bank",
    "luat,rule,legacy",
    "san xuat,buon ban,sale,business,thuong mai,tm ,xnk,kinh doanh",
    'bao hiem,life,insurance',
    'du lich,travel,tour'
]

def get_group(text, industry):
    text = text+ ' '+industry
    if type(text)==str:
        text = convert_accented_vietnamese_text(text)
    else:
        return 'None'
    for index,group in enumerate(FUNCTIONS):
        constant = '|'.join(group.split(','))
        if re.findall(constant,text):
            return index
    else:
        return 'None'

all_company = pd.read_csv('all_company.csv').astype(str)
all_company['function'] = all_company.apply(lambda x: get_group(x.company_name, x.industry), axis=1)
all_company

none_function = all_company[all_company['function']=='None']
match_function = all_company[all_company['function']!='None']

from flashtext import KeywordProcessor

def get_function_from_sentence(text):
    keyword_processor = KeywordProcessor()
    for index, function in enumerate(FUNCTIONS):
        keyword_processor.add_keywords_from_list(function.split(','))
        if keyword_processor.extract_keywords(text):
            return index
    else:
        return None

from bs4 import BeautifulSoup

none_function.head()

def get_results(query):
    
    query = urllib.parse.quote_plus(query)
    response = get_source("https://www.google.co.uk/search?q=" + query)
    
    return response

def parse_results(response):
    
    css_identifier_result = ".tF2Cxc"
    css_identifier_title = "h3"
    css_identifier_link = ".yuRUbf a"
    css_identifier_text = ".VwiC3b"
    
    results = response.html.find(css_identifier_result)

    output = []
    
    for result in results:
        if result.find(css_identifier_text, first=True):
            item = result.find(css_identifier_text, first=True).text
            output.append(item)
        else:
            continue
        
    return output

def google_search(query):
    response = get_results(query)
    return parse_results(response)

def get_source(url):
    """Return the source code for the provided URL. 

    Args: 
        url (string): URL of the page to scrape.

    Returns:
        response (object): HTTP response object from requests_html. 
    """

    try:
        session = HTMLSession()
        response = session.get(url)
        return response

    except requests.exceptions.RequestException as e:
        print(e)

def function_from_company(query):
    results = google_search(query)
    text = results[0]
    return get_function_from_sentence(text)

none_function.head()

from tqdm import tqdm
functions = []
for query in tqdm(none_function['company_name'].values):
    functions.append(function_from_company(query))
none_function['function'] = functions
df = pd.concat([match_function, none_function], axis=0)
df.to_csv('company_function.csv', index=False)

